︠28294f75-b33c-4ab4-8287-300acd4b36dai︠
%md

### An AES round

Each round of AES consists of the following steps.

1. Byte substitution step  (SubBytes)
2. Transposition step (swapping bytes around, called ShiftRows)
3. State mixing step (MixColumns)
4. Mixing with subkey (AddRoundKey) 

In the final round, step MixColumns is omitted.  

![img](https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Fstatic.commonlounge.com%2Ffp%2F600w%2Fy6UQ3zYSQRlWMrW537E7ooK1m1520492304_kc&f=1&nofb=1)



︡daa9bbba-9499-42d0-acf1-a1c99ed8b6c3︡{"done":true,"md":"\n### An AES round\n\nEach round of AES consists of the following steps.\n\n1. Byte substitution step  (SubBytes)\n2. Transposition step (swapping bytes around, called ShiftRows)\n3. State mixing step (MixColumns)\n4. Mixing with subkey (AddRoundKey) \n\nIn the final round, step MixColumns is omitted.  \n\n![img](https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Fstatic.commonlounge.com%2Ffp%2F600w%2Fy6UQ3zYSQRlWMrW537E7ooK1m1520492304_kc&f=1&nofb=1)"}
︠f58f396c-fea6-4a8a-a5cb-23eeed6a8a20i︠
%md


### Fiestel structure vs AES

In DES, which had a Fiestel structure, decryption was just "going up" the diagram rather than going down.

In AES, by contrast, each component layer is invertible (see diagram above).


︡20f029ed-0cf2-47da-a89b-5f7bfcf652df︡{"done":true,"md":"\n\n### Fiestel structure vs AES\n\nIn DES, which had a Fiestel structure, decryption was just \"going up\" the diagram rather than going down.\n\nIn AES, by contrast, each component layer is invertible (see diagram above)."}
︠f9981dc7-db30-41df-bf1d-e5947c9b2a74i︠
%md
### Matrix multiplication

The AES algorithm makes use of matrix multiplication in SubBytes and MixColumns.

You might be familiar with how matrix multiplication works over the integers or real numbers.

![img](https://i.stack.imgur.com/oFncU.png)
︡da176cf5-263d-42b4-9da0-6234c0bdd886︡{"done":true,"md":"### Matrix multiplication\n\nThe AES algorithm makes use of matrix multiplication in SubBytes and MixColumns.\n\nYou might be familiar with how matrix multiplication works over the integers or real numbers.\n\n![img](https://i.stack.imgur.com/oFncU.png)"}
︠41495d8d-3cc2-42b0-beb0-97c64032b5fbs︠
A = matrix(ZZ,[[5,2,6,1],[0,6,2,0],[3,8,1,4],[1,8,5,6]])
B = matrix(ZZ,[[7,5,8,0],[1,8,2,6],[9,4,3,8],[5,3,7,9]])
A*B
︡0f5845af-9d3a-406f-bfe3-281a195d63ac︡{"stdout":"[ 96  68  69  69]\n[ 24  56  18  52]\n[ 58  95  71  92]\n[ 90 107  81 142]\n"}︡{"done":true}
︠5ad21c6b-7564-4aff-bae9-962f608700b9i︠
%md

### Matrix times a vector

To understand AES the only matrix operations we really need involve mutiplying a matrix times a vector.

︡6e541d84-2a31-441e-8772-e48968679307︡{"done":true,"md":"\n### Matrix times a vector\n\nTo understand AES the only matrix operations we really need involve mutiplying a matrix times a vector."}
︠2bb6c749-d7c7-4e99-9aa3-a8fc3c5207b6s︠
v = vector(ZZ,[1,2,3,4])
A*v
︡44cda2c1-d42f-4007-8682-cd99700be2ec︡{"stdout":"(31, 18, 38, 56)\n"}︡{"done":true}
︠209926cc-96a9-4bd2-a730-04d13b526f8di︠
%md

\[
\left(\begin{array}{rrrr}
5 & 2 & 6 & 1 \\
0 & 6 & 2 & 0 \\
3 & 8 & 1 & 4 \\
1 & 8 & 5 & 6
\end{array}\right)\cdot \left(\begin{array}{rrrr}
1 &\\ 2 &\\ 3 &\\ 4\end{array}\right)= \left(\begin{array}{rrrr} 31 &\\ 18 &\\ 38 &\\ 56 \end{array}\right)
\]
︡ed34ada9-45cd-4fcd-888d-c5e2c67a4f3d︡{"done":true,"md":"\n\\[\n\\left(\\begin{array}{rrrr}\n5 & 2 & 6 & 1 \\\\\n0 & 6 & 2 & 0 \\\\\n3 & 8 & 1 & 4 \\\\\n1 & 8 & 5 & 6\n\\end{array}\\right)\\cdot \\left(\\begin{array}{rrrr}\n1 &\\\\ 2 &\\\\ 3 &\\\\ 4\\end{array}\\right)= \\left(\\begin{array}{rrrr} 31 &\\\\ 18 &\\\\ 38 &\\\\ 56 \\end{array}\\right)\n\\]"}
︠c5e41182-fca3-4bbd-a503-6ac9355d9c89i︠
%md

### Matrix multiplication on bytes

In the above examples the "lower level" object that support the multiplication come from the ring $\mathbb{Z}$.

But you can do matrix multiplication with members from any ring.

That's because matrix multiplication just uses multiplication and addition (which all rings support by definition).

In AES there is, in SubBytes, a multiplication of matrixes where the underlying ring is GF(2)= $\mathbb{Z_2}$.

In MixColumns, the underlying ring is $GF(2^8)$.

We will first consider the GF(2) case (SubBytes).  

This is part of the AES S-box.

︡8259bc0a-de3d-4257-ac90-cef8734b6ab8︡{"done":true,"md":"\n### Matrix multiplication on bytes\n\nIn the above examples the \"lower level\" object that support the multiplication come from the ring $\\mathbb{Z}$.\n\nBut you can do matrix multiplication with members from any ring.\n\nThat's because matrix multiplication just uses multiplication and addition (which all rings support by definition).\n\nIn AES there is, in SubBytes, a multiplication of matrixes where the underlying ring is GF(2)= $\\mathbb{Z_2}$.\n\nIn MixColumns, the underlying ring is $GF(2^8)$.\n\nWe will first consider the GF(2) case (SubBytes).  \n\nThis is part of the AES S-box."}
︠479bc472-cc5d-4739-ac14-0a767817ba80i︠
%md

### The affine transform (part of SubBytes)

The so-called affine transform is a matrix operation on bytes.

Here a byte is understood to be 8 bits.

So a byte is a length 8 vector of bits (aka elements from $\mathbb{Z}_2$).

We can apply an 8x8 square matrix of bits to a byte to produce a new byte.

In this case the particular matrix used is a fixed part of AES.

After the matrix multiplication, another fixed binary vector is added.

#### the affine transform

![img](affinetransform.png)
︡96f89180-c15f-4647-b441-1d79017b2e89︡{"done":true,"md":"\n### The affine transform (part of SubBytes)\n\nThe so-called affine transform is a matrix operation on bytes.\n\nHere a byte is understood to be 8 bits.\n\nSo a byte is a length 8 vector of bits (aka elements from $\\mathbb{Z}_2$).\n\nWe can apply an 8x8 square matrix of bits to a byte to produce a new byte.\n\nIn this case the particular matrix used is a fixed part of AES.\n\nAfter the matrix multiplication, another fixed binary vector is added.\n\n#### the affine transform\n\n![img](affinetransform.png)"}
︠ddf5790c-517b-4a6c-a6fe-c1bd5cadc099s︠
M_at = matrix(Zmod(2),[[1,0,0,0,1,1,1,1],[1,1,0,0,0,1,1,1],[1,1,1,0,0,0,1,1],[1,1,1,1,0,0,0,1],[1,1,1,1,1,0,0,0],[0,1,1,1,1,1,0,0],[0,0,1,1,1,1,1,0],[0,0,0,1,1,1,1,1]])
M_at
︡c3020093-2834-4dbd-abb8-693c987630e5︡{"stdout":"[1 0 0 0 1 1 1 1]\n[1 1 0 0 0 1 1 1]\n[1 1 1 0 0 0 1 1]\n[1 1 1 1 0 0 0 1]\n[1 1 1 1 1 0 0 0]\n[0 1 1 1 1 1 0 0]\n[0 0 1 1 1 1 1 0]\n[0 0 0 1 1 1 1 1]\n"}︡{"done":true}
︠d3a79f0c-b89d-46ed-bed7-23a27333eda1s︠
v_at = vector(Zmod(2),[1,1,0,0,0,1,1,0])
v_at
︡612966b5-4af8-48f9-add8-5c65d3de60c5︡{"stdout":"(1, 1, 0, 0, 0, 1, 1, 0)\n"}︡{"done":true}
︠35f6c7e5-848e-4a85-bab1-5df995ccf6d6s︠
x = vector(Zmod(2),[1,0,1,1,0,0,0,1])
︡000c1a6d-3f32-4640-b889-1adac9112953︡{"done":true}
︠33eba424-477b-41d9-9e0c-63616a9c1784s︠
def affine_transform(x):
    return M_at*x+v_at

affine_transform(x)
︡d0e1167a-7753-4ebc-a4ac-1da2ea828f95︡{"stdout":"(1, 1, 1, 0, 1, 1, 1, 0)"}︡{"stdout":"\n"}︡{"done":true}
︠6a51160a-87eb-4c9c-a288-c881acbfd695i︠
%md

### The SubBytes layer

We can now fully understand the SubBytes layer.

It is a transformation on bytes $b$.

1. The byte b is replaced by its inverse in GF(256)
2. The affine transform is applied to the result.


Because both of these steps are invertible, the entire SubBytes operation is invertible.



︡cb5ed350-f01e-4568-a64f-9c4f20b09dad︡{"done":true,"md":"\n### The SubBytes layer\n\nWe can now fully understand the SubBytes layer.\n\nIt is a transformation on bytes $b$.\n\n1. The byte b is replaced by its inverse in GF(256)\n2. The affine transform is applied to the result.\n\n\nBecause both of these steps are invertible, the entire SubBytes operation is invertible."}
︠dc67220d-84f4-4c6c-8ba2-1a647e59fdbci︠
%md

### Inverse affine transform

Notice that the affine transform is invertible.

If the affine transform is:

$$\bar{y} = M\bar{x}+v$$

then

$$M^{-1}(\bar{y}-v) = x$$

or equivalently

$$M^{-1}\bar{y}-M^{-1}v = x$$

︡51aa299c-4060-41d7-9647-437af95bdfb7︡{"done":true,"md":"\n### Inverse affine transform\n\nNotice that the affine transform is invertible.\n\nIf the affine transform is:\n\n$$\\bar{y} = M\\bar{x}+v$$\n\nthen\n\n$$M^{-1}(\\bar{y}-v) = x$$\n\nor equivalently\n\n$$M^{-1}\\bar{y}-M^{-1}v = x$$"}
︠b9274814-9f90-43c9-9253-2f182da4040ds︠
M_at.inverse()
︡0a61e9c5-3cef-439e-bec7-c56b344fff47︡{"stdout":"[0 0 1 0 0 1 0 1]\n[1 0 0 1 0 0 1 0]\n[0 1 0 0 1 0 0 1]\n[1 0 1 0 0 1 0 0]\n[0 1 0 1 0 0 1 0]\n[0 0 1 0 1 0 0 1]\n[1 0 0 1 0 1 0 0]\n[0 1 0 0 1 0 1 0]\n"}︡{"done":true}
︠bea9353a-bd1f-4849-9043-48442ca52aa9s︠
M_at.inverse()*v_at
︡b307cf13-0fac-4261-9882-2511c87e2a68︡{"stdout":"(1, 0, 1, 0, 0, 0, 0, 0)\n"}︡{"done":true}
︠c0579528-2054-43ad-a511-aae2e114c6b3s︠
def inverse_affine_transform(y):
    return M_at.inverse()*(y-v_at)

x

︡2451ee42-2272-406d-bcac-9aa45e090c91︡{"stdout":"(1, 0, 1, 1, 0, 0, 0, 1)\n"}︡{"done":true}
︠da7ca13b-6088-4efb-9157-e8e2620ae653s︠
affine_transform(x)
︡a4ac77b8-9a84-4f43-808b-e589ada1bdbf︡{"stdout":"(1, 1, 1, 0, 1, 1, 1, 0)\n"}︡{"done":true}
︠6e99c8dd-fb08-46ad-a2ab-149ba2e9fb68s︠
inverse_affine_transform(affine_transform(x))
︡1bab502d-6b97-4125-a61f-3ef286337be1︡{"stdout":"(1, 0, 1, 1, 0, 0, 0, 1)\n"}︡{"done":true}
︠862e2d5f-4d98-4048-8617-7bbc74912885i︠
%md

### inverse SubBytes

![img](https://image.slidesharecdn.com/imageencryptionusingaeskeyexpansion-130319103134-phpapp02/95/image-encryption-using-aes-key-expansion-16-638.jpg?cb=1363689311)

︡ed66c965-46a6-41b0-b533-d8442f9cbc92︡{"done":true,"md":"\n### inverse SubBytes\n\n![img](https://image.slidesharecdn.com/imageencryptionusingaeskeyexpansion-130319103134-phpapp02/95/image-encryption-using-aes-key-expansion-16-638.jpg?cb=1363689311)"}
︠4b4e8133-119a-4d53-a49c-3297ff57a363︠

︡1a89336a-fb7d-443f-8e5c-82c7b65844c3︡
︠9fe64e4e-87db-44ed-9311-e198bcd78885i︠
%md

### SBox Implementation in C

Sam Trenholme has an excellent presentation of AES elements in C.


https://www.samiam.org/s-box.html


In practice you can just make a substitution table that encapsulates all of the above (see the link).

︡c9780d68-1d56-4203-b1ed-233f88b02d1c︡{"done":true,"md":"\n### SBox Implementation in C\n\nSam Trenholme has an excellent presentation of AES elements in C.\n\n\nhttps://www.samiam.org/s-box.html\n\n\nIn practice you can just make a substitution table that encapsulates all of the above (see the link)."}
︠561e88cd-0508-4bfd-88d1-415f23ba5f69i︠
%md

### AES internal state

Recall that DES had a 64 bit internal state that was updated throughout the algorithm.

The state is initially the input.

After several rounds of updating, the internal state is the output.

AES works the same way.

But now the internal state is 128 bits.

But we think of this as a 4x4 array of bytes.

![img](aes_state.png)

In AES one of the ways this state is updated is through matrix multiplication.

But the bytes are regarded as elements of GF(256) when they are multiplied.

︡0047c9ec-7dc4-4cec-ae4e-eeedf5cdeb6f︡{"done":true,"md":"\n### AES internal state\n\nRecall that DES had a 64 bit internal state that was updated throughout the algorithm.\n\nThe state is initially the input.\n\nAfter several rounds of updating, the internal state is the output.\n\nAES works the same way.\n\nBut now the internal state is 128 bits.\n\nBut we think of this as a 4x4 array of bytes.\n\n![img](aes_state.png)\n\nIn AES one of the ways this state is updated is through matrix multiplication.\n\nBut the bytes are regarded as elements of GF(256) when they are multiplied."}
︠999a520b-18ff-4aff-a4b8-e2c022c18d13i︠
%md

###  MixColumns

In the MixColumns stage in AES we need to do matrix multiplication, but where the entries of the matrix are not bits but bytes.

And when we multiply bytes we will not multiply their decimal value.

We will instead compute their product **as elements of GF(256)** as discussed earlier.

As before though, all we need is the product of a square matrix and a vector.

Here is the product that we need:

![img](mixcol.png)


The point here is that the C vector (left hand side) is now a "mixture" of the B vector (right hand side).


Thus this operation "mixes columns".

︡3d83b1f4-8ef9-4e70-bf9e-ec141f073289︡{"done":true,"md":"\n###  MixColumns\n\nIn the MixColumns stage in AES we need to do matrix multiplication, but where the entries of the matrix are not bits but bytes.\n\nAnd when we multiply bytes we will not multiply their decimal value.\n\nWe will instead compute their product **as elements of GF(256)** as discussed earlier.\n\nAs before though, all we need is the product of a square matrix and a vector.\n\nHere is the product that we need:\n\n![img](mixcol.png)\n\n\nThe point here is that the C vector (left hand side) is now a \"mixture\" of the B vector (right hand side).\n\n\nThus this operation \"mixes columns\"."}
︠feb0602e-7e07-4d96-af4e-481fd0984f70︠
%md

### Observations  

This matrix is a constant feature of AES -- the values are baked in.

For now ignore the weird subscripts on the Bs.

All the B and C variables are bytes.

The entries of the matrix are also bytes.

When multiplication takes place, it is GF(256) multiplication.

So you could see

$01 = 1$

$02 = x$

and

$03 = x+1$.



︡c57dabdf-b3da-4bb1-b497-00f5a6590537︡{"done":true,"md":"\n### Observations  \n\nThis matrix is a constant feature of AES -- the values are baked in.\n\nFor now ignore the weird subscripts on the Bs.\n\nAll the B and C variables are bytes.\n\nThe entries of the matrix are also bytes.\n\nWhen multiplication takes place, it is GF(256) multiplication.\n\nSo you could see\n\n$01 = 1$\n\n$02 = x$\n\nand\n\n$03 = x+1$."}
︠4c6eadf1-f86c-4ee1-af9f-41a6acfa9787︠
WLoar
︡86028352-c966-473e-aa61-20d73e1bfa98︡{"done":true}
︠2ac58b1d-1453-4654-8ae5-cb81443727bds︠
R.<x> = PolynomialRing(Zmod(2))
F = GF(2**8,"x",modulus=x^8+x^4+x^3+x+1)

p_1 = F("1")
p_2 = F("x")
p_3 = F("x+1")
MC_aes = matrix(F,[[p_2,p_3,p_1,p_1],[p_1,p_2,p_3,p_1],[p_1,p_1,p_2,p_3],[p_3,p_1,p_1,p_2]])
MC_aes
︡7f29c1bf-1f09-41bd-b06d-760bd7cb08ec︡{"stdout":"[    x x + 1     1     1]\n[    1     x x + 1     1]\n[    1     1     x x + 1]\n[x + 1     1     1     x]\n"}︡{"done":true}
︠6c2d5b2e-0aa6-496c-8c75-b0391f645d4fs︠

︡5b4f7190-6fb5-4de7-9a4f-370f499d4388︡{"done":true}
︠2038b697-2340-48ee-80bd-7054b506caf5s︠

︡d05039cf-17c3-4b5e-aedb-b3090b1ce1b0︡{"done":true}
︠5e8519be-513c-4c65-b1a4-32864ddd598as︠
︡c8ecc985-6a9a-4740-88d2-d51d8ef77195︡{"done":true}
︠cc4cfdf6-ee89-41fa-af29-4dd25fa23054s︠



︡2eb67f81-a6ec-4653-a034-bf9c190ba452︡{"done":true}
︠8e14503b-8905-454f-89e0-d5f83e6c471ds︠
︡74388557-c6b4-4a21-8574-b7cc3b108b04︡{"done":true}
︠02f64aad-2bd4-44a5-a9ab-145e104c8333︠










